# DroneSimulator_TFG
Simulate a drone on gazebo.

### First Steps
#### Init Workspace and Install Ros pckg

Create a Ros workspace running the following steps.

```
sudo apt get ros-noetic-geographic-msgs
mkdir -p ~/<YOUR-WORKSPACE-NAME>/src
cd ~/<YOUR-WORKSPACE-NAME>/
catkin_make
cd ~/src
git clone https://github.com/SergioFerrando/DroneSimulator_TFG.git
cd ~/<YOUR-WORKSPACE-NAME>/
catkin_make
```

Installations before first execution

```
sudo apt-get install python3
sudo apt-get install python3-pip
pip install getch
sudo pip3 install tornado
sudo pip3 install simplejpeg
sudo pip3 install rospkg
https://github.com/leggedrobotics/darknet_ros#download-weights 
```

### Run
#### Gazebo
```
roslaunch drone_basic bring_hector_drone.launch
```

#### Control Drone Keyboard
```
rosrun drone_basic conducir_drone.py
```


#### Run Web Application ROS
```
rosrun rosboard rosboard_node 
```

#### YOLO Image view
```
roslaunch darknet_ros darknet_ros.launch
```

#### Hector Slam (Map creation)
```
roslaunch hector_slam hector_slam.launch
rosrun map_server map_saver -f <FilePath>
```

#### Hector navigation
```
roslaunch hector_slam hector_navigation.launch
```
